#include "hpnsUtil.h"
#include "tmodule.h"
#include "hpnsAppEngine.h"
#include "hpnsConfig.h"
#include "hpnsHttpPost.h"
#include "hpnsStm.h"

void notificationMsgCallBack(char *msg, int msgLen);
void registerCallback(int appId, char regId[]);
#ifdef __ANDROIDOS__
	#include <jni.h>
	extern jclass g_classAdp;
	extern JavaVM* g_JavaVm;
	extern JNIEnv* g_jniEnv;
	extern jclass g_regInfoClass;
#endif

int byteArrayToHexStr(char bytes[], int len, char hexstr[]) 
{ 
	int i; 
	char hexval[16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'}; 

	for(i = 0; i < len; i++) 
	{ 
	hexstr[i*2] = hexval[((bytes[i] >> 4) & 0xF)]; 
	hexstr[(i*2) + 1] = hexval[(bytes[i]) & 0x0F]; 
	} 
	return; 
} 


void registerCallback(int appId, char regId[])
{

}

void notificationMsgCallBack(char *msg, int msgLen)
{
}


#ifdef __ANDROIDOS__
	#define InitJNI(functionname, classinstance)	\
			JNIEnv* env = NULL;		\
			int code = JNI_OK;		\
			code = (*g_JavaVm)->GetEnv(g_JavaVm, (void**)&env, JNI_VERSION_1_2); \
			if (code != JNI_OK) {	\
				nprintf((char*)"get jni env %x error at function: %s, code:%d, reason:%s",(void*)&g_JavaVm, functionname, code, strerror(errno));	\
        			return;					\
		    	}						\
			jobject msgObj = NULL;				\
			msgObj = (*env)->AllocObject(env, classinstance);
		
	#define SetField(id, type, value, classinstance)  {	\
			jfieldID j##id=(*env)->GetFieldID(env, classinstance, ""#id"", type);	\
			if(strcmp(type, "I") == 0){	\
				(*env)->SetIntField(env, msgObj, j##id, (jint)value);\
			}else if(strcmp(type, "Ljava/lang/String;") == 0){		\
				jstring jStrLineOne = (*env)->NewString(env, (jchar*)value, hpnsUcs2Strlen((char*)value));	\
				(*env)->SetObjectField(env, msgObj, j##id, jStrLineOne); 			\
				(*env)->DeleteLocalRef(env, jStrLineOne);					\
			}								\
		}

	#define CallJNIMethod(method, params)	\
		jmethodID j##method = (*env)->GetStaticMethodID(env, g_classAdp, ""#method"",params);	\
		(*env)->CallStaticVoidMethod(env,g_classAdp,j##method, msgObj);	\
		jthrowable exc;	          \
		exc = (*env)->ExceptionOccurred(env); \
     		if (exc) {			\
			nprintf("callmethod %s error", ""#method""); \
     		}	

	#define DestroyJNI(functionname)	\
		(*env)->DeleteLocalRef(env,msgObj);

		
#endif

int hpnsUiSendNotificationToNS(SHpnsRegInfo *pHpnsRegInfo, int msgid)
{

#ifdef __ANDROIDOS__
	char  tempstr[32] = {0};
	unsigned char  wcharstr[64] = {0};
	int len = 0;
	//byteArrayToHexStr(pHpnsRegInfo->regId, 12, tempstr);
	nprintf("new reg id:%s", pHpnsRegInfo->regId);
        hpnsUtf82Usc2Str(pHpnsRegInfo->regId, sizeof(pHpnsRegInfo->regId),wcharstr, &len);
	//hpnsEngineAdapterSendNotificationToNS(regStr, i++, 300, "good");
	InitJNI("hpnsUiSendNotificationToNS", g_regInfoClass);
	//jfieldID jregstr = (*env)->GetFieldID(env, g_summaryClass, "regstr", "Ljava/lang/String;"); 
	//jfieldID jmessageid = (*env)->GetFieldID(env, g_summaryClass, "messageid", "I");  
	//jfieldID jexpire = (*env)->GetFieldID(env, g_summaryClass, "expire", "I");  
	//jfieldID jpayload = (*env)->GetFieldID(env, g_summaryClass, "payload", "Ljava/lang/String;"); 
	SetField(appid, "I", (int)pHpnsRegInfo->appId, g_regInfoClass);
	SetField(code, "I", (int)pHpnsRegInfo->appCode, g_regInfoClass);
	SetField(regstr, "Ljava/lang/String;", wcharstr, g_regInfoClass);
	SetField(messageid, "I", msgid, g_regInfoClass);
	SetField(expire, "I", 300, g_regInfoClass);
	SetField(payload, "Ljava/lang/String;", "good", g_regInfoClass);
	CallJNIMethod(SendNotificationToNS,"(Ljava/lang/Object;)V");
	DestroyJNI("hpnsUiSendNotificationToNS");
        //test
	//hpnsSendMsgToNs(3, "hello world");
	//CallJNIMethod(ProcessNotification, "()V");
	return 0;
#endif
	char* params[10];
	int i = 0,k;
	char  regStr[32] = {0};

	//byteArrayToHexStr(pHpnsRegInfo->regId, 12, regStr);

	registerCallback(pHpnsRegInfo->appId, pHpnsRegInfo->regId);
	
	return 0;
}


int hpnsUiProcessNotification(UINT8 *pMsg, int msgLen)
{
#ifdef __ANDROIDOS__
        //char  tempstr[32] = {0};
        unsigned char  wcharstr[2048] = {0};
        int len = 0;

	//hpnsEngineAdapterProcessNotification(pMsg, msgLen)
	//nprintf("msg len:%d , msg content:%x", msgLen, pMsg);
	SHpnsRegInfo *pInfo = (SHpnsRegInfo *)pMsg;
	//nprintf("new message:%s", pInfo->payload);
        hpnsUtf82Usc2Str(pInfo->payload, strlen(pInfo->payload),wcharstr, &len);

	InitJNI("hpnsUiProcessNotification", g_regInfoClass);

        SetField(appid, "I", (int)pInfo->appId, g_regInfoClass);
        SetField(code, "I", (int)pInfo->appCode, g_regInfoClass);

	SetField(regstr, "Ljava/lang/String;", "content", g_regInfoClass);
	SetField(messageid, "I", msgLen - sizeof(SHpnsRegInfo) + 1, g_regInfoClass);
	SetField(expire, "I", 300, g_regInfoClass);
	SetField(payload, "Ljava/lang/String;", wcharstr, g_regInfoClass);
	CallJNIMethod(ProcessNotification,"(Ljava/lang/Object;)V");
	DestroyJNI("hpnsUiProcessNotification");
	hpnsSendMsgToEngine(HPNS_MSG_NOTIFICATION_RSP, (UINT8*)pInfo->appId, 0);
	return 0;
#endif
	nprintf("msg len:%d , msg content:%s", msgLen, pMsg);
	SHpnsRegInfo *pRegInfo = (SHpnsRegInfo *)pMsg;
	
	nprintf("msg len:%d , msg content:%s", msgLen - sizeof(SHpnsRegInfo) + 1, pRegInfo->payload);
	notificationMsgCallBack(pRegInfo->payload, msgLen - sizeof(SHpnsRegInfo) + 1);

	return 0;
}


int hpnsUiProcessMsgQueue(msg_t *param)
{
	msg_t *pMsg;
	SHpnsRegInfo *pHpnsRegInfo = 0;

	pMsg = (msg_t *)param;

	nprintf ("msg:%s is received by UI", hpnsAppEngineMsg[pMsg->mid]);

	if( HPNS_MSG_NOTIFICATION == pMsg->mid )
	{
		hpnsUiProcessNotification(pMsg->msg, pMsg->tid);
	}
	else if( (HPNS_MSG_REG_RSP == pMsg->mid) ||(HPNS_MSG_REGID_CHANGED_NOTIFICATION == pMsg->mid))
	{
		if(pMsg->tid == 0 )
		{
			return;
		}
		
		pHpnsRegInfo = ( SHpnsRegInfo *)(pMsg->msg);
		nprintf("appid:%d, error code:%d", pHpnsRegInfo->appId, pHpnsRegInfo->appCode);

		hpnsUiSendNotificationToNS(pHpnsRegInfo, pMsg->mid);

		if(pHpnsRegInfo->appCode == 0 )
		{
			nprintf("sends regId to AS, appId:%u, regId:%s", pHpnsRegInfo->appId, \
					pHpnsRegInfo->regId);
			//hpnsUiSendNotificationToNS(pHpnsRegInfo, pMsg->mid);

			//for simulater
			if( pHpnsRegInfo->appId == 3)
				nprintf("send next app bunding");
			else if( pHpnsRegInfo->appId == 2)
				nprintf("send a error app bunding");
		}
	}
	else if(HPNS_MSG_UNREG_RSP == pMsg->mid )
	{

		pHpnsRegInfo = ( SHpnsRegInfo *)(pMsg->msg);
                hpnsUiSendNotificationToNS(pHpnsRegInfo, pMsg->mid);
		if(pMsg->tid == 0 )
		{
			return;
		}
		else
		{
			if(pHpnsRegInfo->appCode == 0)

				nprintf("unreg sucessfully.");
			else
			{
				nprintf("appid:%d, code:%d", pHpnsRegInfo->appId, pHpnsRegInfo->appCode);
			}
		}
		
	}

	if ( pMsg->tid == 0 ) 
		pMsg->msg = NULL;
	
	return 0;
}

int hpnsInitUi(void *param)
{
	return 0;
}

void hpnsCleanUpUi()
{
	return;
}

#ifdef __ANDROIDOS__
//added 
void hpnsSendAuthReqToEngine(int appid, char* paccountid)
{
	LOGI((char*)"hpnsSendAuthReqToEngine, appId:%d, accountid:%s", appid, paccountid);
	SHpnsAppProfile appprofile = {0};
	strncpy((char*)appprofile.senderId, paccountid, sizeof(appprofile.senderId));
	appprofile.appId = appid;
	hpnsSendMsgToEngine(HPNS_MSG_REG_REQ, (UINT8 *)(&appprofile), sizeof(SHpnsAppProfile));
}

void hpnsSendUnReqToEngine(int appid, char* paccountid)
{
	LOGI((char*)"hpnsSendUnReqToEngine, appId:%d, accountid:%s", appid, paccountid);
	SHpnsAppProfile appprofile = {0};
	strncpy((char*)appprofile.senderId, paccountid, sizeof(appprofile.senderId));
	appprofile.appId = appid;
	hpnsSendMsgToEngine(HPNS_MSG_UNREG_REQ, (UINT8 *)appid, 0);
}

void hpnsSendNetworkStatusChangedReqToEngine(int flag)
{
	LOGI((char*)"hpnsSendNetworkStatusChangedReqToEngine, flag:%d", flag);
	hpnsSendMsgToEngine(HPNS_MSG_NETWORK_STATE_CHANGED, (UINT8*)flag, 0);
}

int hpnsCheckChangeIp(char *domain, char *newIp, int startPort, int portNum, int tcpPort)
{
	SHpnsPushServerInfo hpnsConfigServerInfo = {0};
	UINT32 pushIP[3] = {0};
	UINT32 ip = 0;
	if(hpnsGetChangeIpInfo(&hpnsConfigServerInfo,pushIP) >= 0)
	{
		if(strcmp(hpnsConfigServerInfo.configDomain,domain)!= 0)
		{
			nprintf("app change service info: domain different: %s ; %s",hpnsConfigServerInfo.configDomain,domain);
			return 0;
		}
		if(hpnsConfigServerInfo.pushPort != startPort)
		{
			nprintf("app change service info: startPort different: %d;%d",hpnsConfigServerInfo.pushPort,startPort);
			return 0;
		}
		if(hpnsConfigServerInfo.pushPortNum != portNum)
		{
			nprintf("app change service info: portNum different: %d;%d",hpnsConfigServerInfo.pushPortNum,portNum);
			return 0;
		}
		if(hpnsConfigServerInfo.pushTcpPort != tcpPort)
		{
			nprintf("app change service info: tcpPort different: %d;%d",hpnsConfigServerInfo.pushTcpPort,tcpPort);
			return 0;
		}
		ip = hpnsHtonl(hpnsIpStrToNum(newIp));
		if(pushIP[0] != ip && pushIP[1] != ip && pushIP[2] != ip)
		{
			nprintf("app change service info: ip different");
			return 0;
		}
		return 1;
	}else
	   return 0;
}
int hpnsRestPushServerInfo(char *domain, char *newIp, int startPort, int portNum, int tcpPort)
{
	SHpnsPushServerInfo hpnsConfigServerInfo = {0};
	char ip[50] = {0};
	
	strcpy(ip,newIp);
	if(hpnsCheckChangeIp(domain, newIp, startPort, portNum, tcpPort) > 0)
	{
		nprintf("app get the same server info,no need change service ip info");
		return 0;
	}
	nprintf("app change the defferent service ip info");
	strncpy((char *)hpnsConfigServerInfo.configDomain, (char *)domain, strlen(domain)>HPNS_MAX_DOMAIN_LEN?HPNS_MAX_DOMAIN_LEN:strlen(domain));
	hpnsConfigServerInfo.pushIP = hpnsIpStrToNum(ip);
	hpnsConfigServerInfo.pushPort = startPort;
	hpnsConfigServerInfo.pushPortNum = portNum;
	hpnsConfigServerInfo.pushTcpPort = tcpPort;

	LOGI((char*)"hpnsRestPushServerInfo, domain:%s, newIp:%u,startPort:%u,portNum:%u,tcpPort:%u", domain, hpnsConfigServerInfo.pushIP, startPort, portNum, tcpPort);

	hpnsCleanPushServerIp();
	hpnsSendMsgToEngine(HPNS_MSG_RECONFIG_PUSH_SERVER, (UINT8 *)(&hpnsConfigServerInfo), sizeof(SHpnsPushServerInfo));
	
	return 0;
}


extern int HPNS_ENG_MSG_TIMER;
void hpnsSendTimerMsgToEngine(int mid)
{
	LOGI((char*)"hpnsSendMsgToEngineP, timerid:%d", mid);
	hpnsSendMsgToEngineP(HPNS_ENG_MSG_TIMER, (UINT8*)mid, 0);
}


extern SHpnsIpAddr hpnsServer;


int hpnsGetServerIP()
{
	return hpnsServer.ip;
}

int hpnsGetServerPort()
{
	return (int)hpnsServer.port;
}


extern SHpnsContext hpnsContext;
int hpnsGetSessionId()
{
	return hpnsContext.remoteSessionId;
}

int hpnsGetLocalSessionId()
{
	return hpnsContext.localSessionId;
}

int hpnsGetStatus()
{
	return (int)hpnsContext.connStatus;
}

UINT8* hpnsGetHID()
{
	return hpnsInfo.hid;
}

int hpnsCheckUpgrade()
{
	return 0;//(int)hpnsInfo.softwareUpdate;
}

int hpnsGetMajorVersion()
{
	return hpnsInfo.deviceInfo.majorVersion;
}

int hpnsGetMinorVersion()
{
	return hpnsInfo.deviceInfo.minorVersion;
}


int hpnsUtf8ToUcs2(const unsigned char *input, WCHAR *output, UINT32 len)
{
	
    if (input[0] < 0x80) 
	{
        *output = input[0];
		if ( input[0] == 0 )
			return 0;
		else
        	return 1;
    }

    if ((input[0] & 0xE0) == 0xE0) {
		if ( len < 3 )
			return -1;
		
		*output =  (( input[0] & 0x0F) << 12 ) | ( (input[1] & 0x3F) << 6 )  | (input[2] & 0x3F);
		return 3;
    }
	
    if ((input[0] & 0xC0) == 0xC0) 
	{
		if (len < 2) 
			return -1;
		
 		*output = ((input[0] & 0x1F) << 6) | (input[1] & 0x3F);
		return 2;
    }
	
    return -1;
}

int hpnsUcs2Strlen (unsigned short *start)
{
  int len = 0;
  char *p = 0;
  
  if(!start)
  	return 0;
  
  p = (char *)start;

  while ( (*p != 0) || (*(p+1) !=0) ) {
    p += 2;
    len++;
  }

  return len;
}

int  hpnsUtf82Usc2Str(unsigned char *input, unsigned int len, unsigned char *output, unsigned int *outputLen) //modify for 11A by wujinyu
{
	int            leftLen = len;
	int            ret;
	unsigned char *pUtf8, *pUcs2;
			
	pUtf8 = input;
	pUcs2 = output;

	while(leftLen > 0)
	{
		ret = hpnsUtf8ToUcs2(pUtf8, (WCHAR *)pUcs2, leftLen);
		if ( ret < 0 )
			break;

		if ( ret == 0 )
			ret = 1;
		
		pUtf8 += ret;
		pUcs2 += 2;

		leftLen -= ret;
	}

	*outputLen = pUcs2 - output;

	return pUtf8 - input;

}

int   hpnsGetAppStatisticsInfo(SHpnsAppStatistics  *hpnsAppStatistic)
{
  
}

#endif



